<?
/**
*
* @package QR Quote
* @version: functions_qr_quote.php - 
* @version $Id: 0001 2010-03-24 23:47:05Z 4seven $
* @copyright (c) 4seven / 2011
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

// request vars
$qr_quote	 = request_var('qr_quote', false);
$qr_post_id	 = request_var('p', 0);
$qr_forum_id = request_var('f', 0);

// only if quoting allowed
if ($auth->acl_get('f_reply', $qr_forum_id)){ 

//  only if variable is given
if ($qr_quote == 'true'){

// need a little part of this
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

     // inital parser
     $message_parser = new parse_message();

        //main engine
        if (!$post_id)
		{
			$user->setup('posting');
			trigger_error('NO_POST');
		}

		// force forum id
		$sql = 'SELECT forum_id
			FROM ' . POSTS_TABLE . '
			WHERE post_id = ' . $qr_post_id;
		$result = $db->sql_query($sql);
		$f_id = (int) $db->sql_fetchfield('forum_id');
		$db->sql_freeresult($result);

		$qr_forum_id = (!$f_id) ? $qr_forum_id : $f_id;	
		
		$sql = 'SELECT p.post_text, p.bbcode_uid, p.post_subject, p.poster_id, p.post_username, u.username
			FROM ' . POSTS_TABLE . ' p, ' . TOPICS_TABLE . ' t, ' . FORUMS_TABLE . ' f, ' . USERS_TABLE . " u
			WHERE p.post_id = $qr_post_id
				AND t.topic_id = p.topic_id
				AND u.user_id = p.poster_id
				AND (f.forum_id = t.forum_id
					OR f.forum_id = $qr_forum_id)" .
				(($auth->acl_get('m_approve', $qr_forum_id)) ? '' : 'AND p.post_approved = 1');

     $result = $db->sql_query($sql);
     $post_data = $db->sql_fetchrow($result);
     $db->sql_freeresult($result);

if (isset($post_data['post_text']))
{
	$message_parser->message = &$post_data['post_text'];
	unset($post_data['post_text']);
}

// determine some vars
if (isset($post_data['poster_id']) && $post_data['poster_id'] == ANONYMOUS)
{
	$post_data['quote_username'] = (!empty($post_data['post_username'])) ? $post_data['post_username'] : $user->lang['GUEST'];
}
else
{
	$post_data['quote_username'] = isset($post_data['username']) ? $post_data['username'] : '';
}


$post_data['bbcode_uid'] = $post_data['bbcode_uid'];
$message_parser->decode_message($post_data['bbcode_uid']);


	if ($config['allow_bbcode'])
	{
		$message_parser->message = '[quote=&quot;' . $post_data['quote_username'] . '&quot;]' . censor_text(trim($message_parser->message)) . "[/quote]\n";				
	}
	else
	{
		$offset = 0;
		$quote_string = "&gt; ";
		$message = censor_text(trim($message_parser->message));
		
		// see if we are nesting. It's easily tricked but should work for one level of nesting
		if (strpos($message, "&gt;") !== false)
		{
			$offset = 10;
		}
		
		$message = utf8_wordwrap($message, 75 + $offset, "\n");

		$message = $quote_string . $message;
		$message = str_replace("\n", "\n" . $quote_string, $message);
		$message_parser->message =  $post_data['quote_username'] . " " . $user->lang['WROTE'] . " :\n" . $message . "\n";
	}
	
	// go to work - spit out template
	$template->assign_vars(array(
    	'QR_QUOTE_SUB' => (!empty($post_data['post_subject'])) ? utf8_normalize_nfc($post_data['post_subject']) : false,
		'QR_QUOTE_TXT' => (!empty($message_parser->message)) ? $message_parser->message : false
	));

}}
		
?>